% Options for packages loaded elsewhere
\PassOptionsToPackage{unicode}{hyperref}
\PassOptionsToPackage{hyphens}{url}
\PassOptionsToPackage{dvipsnames,svgnames,x11names}{xcolor}
%
\documentclass[
  letterpaper,
  DIV=11,
  numbers=noendperiod]{scrartcl}

\usepackage{amsmath,amssymb}
\usepackage{iftex}
\ifPDFTeX
  \usepackage[T1]{fontenc}
  \usepackage[utf8]{inputenc}
  \usepackage{textcomp} % provide euro and other symbols
\else % if luatex or xetex
  \usepackage{unicode-math}
  \defaultfontfeatures{Scale=MatchLowercase}
  \defaultfontfeatures[\rmfamily]{Ligatures=TeX,Scale=1}
\fi
\usepackage{lmodern}
\ifPDFTeX\else  
    % xetex/luatex font selection
    \setmainfont[]{TeX Gyre Pagella}
    \setmonofont[]{Latin Modern Mono}
\fi
% Use upquote if available, for straight quotes in verbatim environments
\IfFileExists{upquote.sty}{\usepackage{upquote}}{}
\IfFileExists{microtype.sty}{% use microtype if available
  \usepackage[]{microtype}
  \UseMicrotypeSet[protrusion]{basicmath} % disable protrusion for tt fonts
}{}
\makeatletter
\@ifundefined{KOMAClassName}{% if non-KOMA class
  \IfFileExists{parskip.sty}{%
    \usepackage{parskip}
  }{% else
    \setlength{\parindent}{0pt}
    \setlength{\parskip}{6pt plus 2pt minus 1pt}}
}{% if KOMA class
  \KOMAoptions{parskip=half}}
\makeatother
\usepackage{xcolor}
\usepackage[top=30mm,left=20mm,heightrounded]{geometry}
\setlength{\emergencystretch}{3em} % prevent overfull lines
\setcounter{secnumdepth}{-\maxdimen} % remove section numbering
% Make \paragraph and \subparagraph free-standing
\makeatletter
\ifx\paragraph\undefined\else
  \let\oldparagraph\paragraph
  \renewcommand{\paragraph}{
    \@ifstar
      \xxxParagraphStar
      \xxxParagraphNoStar
  }
  \newcommand{\xxxParagraphStar}[1]{\oldparagraph*{#1}\mbox{}}
  \newcommand{\xxxParagraphNoStar}[1]{\oldparagraph{#1}\mbox{}}
\fi
\ifx\subparagraph\undefined\else
  \let\oldsubparagraph\subparagraph
  \renewcommand{\subparagraph}{
    \@ifstar
      \xxxSubParagraphStar
      \xxxSubParagraphNoStar
  }
  \newcommand{\xxxSubParagraphStar}[1]{\oldsubparagraph*{#1}\mbox{}}
  \newcommand{\xxxSubParagraphNoStar}[1]{\oldsubparagraph{#1}\mbox{}}
\fi
\makeatother

\usepackage{color}
\usepackage{fancyvrb}
\newcommand{\VerbBar}{|}
\newcommand{\VERB}{\Verb[commandchars=\\\{\}]}
\DefineVerbatimEnvironment{Highlighting}{Verbatim}{commandchars=\\\{\}}
% Add ',fontsize=\small' for more characters per line
\usepackage{framed}
\definecolor{shadecolor}{RGB}{241,243,245}
\newenvironment{Shaded}{\begin{snugshade}}{\end{snugshade}}
\newcommand{\AlertTok}[1]{\textcolor[rgb]{0.68,0.00,0.00}{#1}}
\newcommand{\AnnotationTok}[1]{\textcolor[rgb]{0.37,0.37,0.37}{#1}}
\newcommand{\AttributeTok}[1]{\textcolor[rgb]{0.40,0.45,0.13}{#1}}
\newcommand{\BaseNTok}[1]{\textcolor[rgb]{0.68,0.00,0.00}{#1}}
\newcommand{\BuiltInTok}[1]{\textcolor[rgb]{0.00,0.23,0.31}{#1}}
\newcommand{\CharTok}[1]{\textcolor[rgb]{0.13,0.47,0.30}{#1}}
\newcommand{\CommentTok}[1]{\textcolor[rgb]{0.37,0.37,0.37}{#1}}
\newcommand{\CommentVarTok}[1]{\textcolor[rgb]{0.37,0.37,0.37}{\textit{#1}}}
\newcommand{\ConstantTok}[1]{\textcolor[rgb]{0.56,0.35,0.01}{#1}}
\newcommand{\ControlFlowTok}[1]{\textcolor[rgb]{0.00,0.23,0.31}{\textbf{#1}}}
\newcommand{\DataTypeTok}[1]{\textcolor[rgb]{0.68,0.00,0.00}{#1}}
\newcommand{\DecValTok}[1]{\textcolor[rgb]{0.68,0.00,0.00}{#1}}
\newcommand{\DocumentationTok}[1]{\textcolor[rgb]{0.37,0.37,0.37}{\textit{#1}}}
\newcommand{\ErrorTok}[1]{\textcolor[rgb]{0.68,0.00,0.00}{#1}}
\newcommand{\ExtensionTok}[1]{\textcolor[rgb]{0.00,0.23,0.31}{#1}}
\newcommand{\FloatTok}[1]{\textcolor[rgb]{0.68,0.00,0.00}{#1}}
\newcommand{\FunctionTok}[1]{\textcolor[rgb]{0.28,0.35,0.67}{#1}}
\newcommand{\ImportTok}[1]{\textcolor[rgb]{0.00,0.46,0.62}{#1}}
\newcommand{\InformationTok}[1]{\textcolor[rgb]{0.37,0.37,0.37}{#1}}
\newcommand{\KeywordTok}[1]{\textcolor[rgb]{0.00,0.23,0.31}{\textbf{#1}}}
\newcommand{\NormalTok}[1]{\textcolor[rgb]{0.00,0.23,0.31}{#1}}
\newcommand{\OperatorTok}[1]{\textcolor[rgb]{0.37,0.37,0.37}{#1}}
\newcommand{\OtherTok}[1]{\textcolor[rgb]{0.00,0.23,0.31}{#1}}
\newcommand{\PreprocessorTok}[1]{\textcolor[rgb]{0.68,0.00,0.00}{#1}}
\newcommand{\RegionMarkerTok}[1]{\textcolor[rgb]{0.00,0.23,0.31}{#1}}
\newcommand{\SpecialCharTok}[1]{\textcolor[rgb]{0.37,0.37,0.37}{#1}}
\newcommand{\SpecialStringTok}[1]{\textcolor[rgb]{0.13,0.47,0.30}{#1}}
\newcommand{\StringTok}[1]{\textcolor[rgb]{0.13,0.47,0.30}{#1}}
\newcommand{\VariableTok}[1]{\textcolor[rgb]{0.07,0.07,0.07}{#1}}
\newcommand{\VerbatimStringTok}[1]{\textcolor[rgb]{0.13,0.47,0.30}{#1}}
\newcommand{\WarningTok}[1]{\textcolor[rgb]{0.37,0.37,0.37}{\textit{#1}}}

\providecommand{\tightlist}{%
  \setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}\usepackage{longtable,booktabs,array}
\usepackage{calc} % for calculating minipage widths
% Correct order of tables after \paragraph or \subparagraph
\usepackage{etoolbox}
\makeatletter
\patchcmd\longtable{\par}{\if@noskipsec\mbox{}\fi\par}{}{}
\makeatother
% Allow footnotes in longtable head/foot
\IfFileExists{footnotehyper.sty}{\usepackage{footnotehyper}}{\usepackage{footnote}}
\makesavenoteenv{longtable}
\usepackage{graphicx}
\makeatletter
\def\maxwidth{\ifdim\Gin@nat@width>\linewidth\linewidth\else\Gin@nat@width\fi}
\def\maxheight{\ifdim\Gin@nat@height>\textheight\textheight\else\Gin@nat@height\fi}
\makeatother
% Scale images if necessary, so that they will not overflow the page
% margins by default, and it is still possible to overwrite the defaults
% using explicit options in \includegraphics[width, height, ...]{}
\setkeys{Gin}{width=\maxwidth,height=\maxheight,keepaspectratio}
% Set default figure placement to htbp
\makeatletter
\def\fps@figure{htbp}
\makeatother
% definitions for citeproc citations
\NewDocumentCommand\citeproctext{}{}
\NewDocumentCommand\citeproc{mm}{%
  \begingroup\def\citeproctext{#2}\cite{#1}\endgroup}
\makeatletter
 % allow citations to break across lines
 \let\@cite@ofmt\@firstofone
 % avoid brackets around text for \cite:
 \def\@biblabel#1{}
 \def\@cite#1#2{{#1\if@tempswa , #2\fi}}
\makeatother
\newlength{\cslhangindent}
\setlength{\cslhangindent}{1.5em}
\newlength{\csllabelwidth}
\setlength{\csllabelwidth}{3em}
\newenvironment{CSLReferences}[2] % #1 hanging-indent, #2 entry-spacing
 {\begin{list}{}{%
  \setlength{\itemindent}{0pt}
  \setlength{\leftmargin}{0pt}
  \setlength{\parsep}{0pt}
  % turn on hanging indent if param 1 is 1
  \ifodd #1
   \setlength{\leftmargin}{\cslhangindent}
   \setlength{\itemindent}{-1\cslhangindent}
  \fi
  % set entry spacing
  \setlength{\itemsep}{#2\baselineskip}}}
 {\end{list}}
\usepackage{calc}
\newcommand{\CSLBlock}[1]{\hfill\break\parbox[t]{\linewidth}{\strut\ignorespaces#1\strut}}
\newcommand{\CSLLeftMargin}[1]{\parbox[t]{\csllabelwidth}{\strut#1\strut}}
\newcommand{\CSLRightInline}[1]{\parbox[t]{\linewidth - \csllabelwidth}{\strut#1\strut}}
\newcommand{\CSLIndent}[1]{\hspace{\cslhangindent}#1}

%\usepackage{mathtools}

% ProvideMathOperator similar to providecommand
\newcommand{\ProvideMathOperator}[2]{\ifdefined#1\else\DeclareMathOperator{#1}{#2}\fi}
\newcommand{\ProvideMathOperatorStar}[2]{\ifdefined#1\else\DeclareMathOperator*{#1}{#2}\fi}

\newcommand{\LetThereBe}[2]{\providecommand{#1}{#2}}
\newcommand{\letThereBe}[3]{\providecommand{#1}[#2]{#3}}
\newcommand{\declareMathematics}[2]{\ProvideMathOperator{#1}{#2}}
\newcommand{\declareMathematicsStar}[2]{\ProvideMathOperatorStar{#1}{#2}}

% PDEs
\newcommand{\Xint}[1]{\mathchoice
	{\XXint\displaystyle\textstyle{#1}}%
	{\XXint\textstyle\scriptstyle{#1}}%
	{\XXint\scriptstyle\scriptscriptstyle{#1}}%
	{\XXint\scriptscriptstyle\scriptscriptstyle{#1}}\!\int}

\newcommand{\XXint}[3]{{\setbox0=\hbox{$#1{#2#3}{\int}$ }\vcenter{\hbox{$#2#3$ }}\kern-.6\wd0}}
\newcommand\avint{\Xint{-}}

\AtBeginDocument{\renewcommand{\d}{\mathrm d}}
%setminus doesn't work for some reason
\AtBeginDocument{\renewcommand{\setminus}{\mathbin{\backslash}}}

\renewenvironment{quote}{
	\list{}{\leftmargin=2
	cm\rightmargin=2cm\topsep=0pt}
	\item\relax\small\itshape
}
{\endlist}
% Simply for testing
\LetThereBe{\foo}{\textrm{FIXME: this is a test!}}

% Font styles
\letThereBe{\mcal}{1}{\mathcal{#1}}

% Sets
\LetThereBe{\C}{\mathbb{C}}
\LetThereBe{\R}{\mathbb{R}}
\LetThereBe{\Z}{\mathbb{Z}}
\LetThereBe{\N}{\mathbb{N}}
\LetThereBe{\Im}{\mathrm{Im}}
\LetThereBe{\Re}{\mathrm{Re}}

% Sets from PDEs
\LetThereBe{\boundary}{\partial}
\letThereBe{\closure}{1}{\overline{#1}}
\letThereBe{\contf}{2}{C^{#2}(#1)}
\letThereBe{\compactContf}{2}{C_c^{#2}(#1)}
\letThereBe{\ball}{2}{B\brackets{#1, #2}}
\letThereBe{\closedBall}{2}{B\parentheses{#1, #2}}
\LetThereBe{\compactEmbed}{\subset\subset}
\letThereBe{\inside}{1}{#1^o}
\LetThereBe{\neighborhood}{\mcal O}
\letThereBe{\neigh}{1}{\neighborhood \brackets{#1}}

% Basic notation - vectors and random variables 
\letThereBe{\vi}{1}{\boldsymbol{#1}} %vector or matrix
\letThereBe{\dvi}{1}{\vi{\dot{#1}}} %differentiated vector or matrix
\letThereBe{\vii}{1}{\mathbf{#1}} %if \vi doesn't work
\letThereBe{\dvii}{1}{\vii{\dot{#1}}} %if \dvi doesn't work

\letThereBe{\rnd}{1}{\mathup{#1}} %random variable
\letThereBe{\vr}{1}{\mathbf{#1}} %random vector or matrix
\letThereBe{\vrr}{1}{\boldsymbol{#1}} %random vector if \vr doesn't work
\letThereBe{\dvr}{1}{\vr{\dot{#1}}} %differentiated vector or matrix

\letThereBe{\vb}{1}{\pmb{#1}} %#TODO
\letThereBe{\dvb}{1}{\vb{\dot{#1}}} %#TODO

\letThereBe{\oper}{1}{\mathsf{#1}}

% Basic notation - general
\letThereBe{\set}{1}{\left\{#1\right\}}
\letThereBe{\brackets}{1}{\left( #1 \right)}
\letThereBe{\parentheses}{1}{\left[ #1 \right]}
\letThereBe{\dom}{1}{\mcal{D}\, \brackets{#1}}
\letThereBe{\complexConj}{1}{\overline{#1}}

% Special symbols
\LetThereBe{\vf}{\varphi}
\LetThereBe{\ve}{\varepsilon}
\LetThereBe{\tht}{\theta}
\LetThereBe{\Tht}{\Theta}
\LetThereBe{\after}{\circ}

% Shorthands
\LetThereBe{\xx}{\vi x}
\LetThereBe{\yy}{\vi y}
\LetThereBe{\XX}{\vi X}
\LetThereBe{\AA}{\vi A}
\LetThereBe{\bb}{\vi b}
\LetThereBe{\vvf}{\vi \vf}
\LetThereBe{\ff}{\vi f}
\LetThereBe{\gg}{\vi g}

% Basic functions
\letThereBe{\absval}{1}{\left| #1 \right|}
\LetThereBe{\id}{\mathrm{id}}
\letThereBe{\floor}{1}{\left\lfloor #1 \right\rfloor}
\letThereBe{\ceil}{1}{\left\lceil #1 \right\rceil}
\declareMathematics{\im}{im} %image
\declareMathematics{\tg}{tg}
\declareMathematics{\sign}{sign}

\declareMathematics{\card}{card} %cardinality
\letThereBe{\setSize}{1}{\left| #1 \right|}

\declareMathematics{\exp}{exp}
\letThereBe{\Exp}{1}{\exp\brackets{#1}}
\letThereBe{\indicator}{1}{\mathbb{1}_{#1}}
\letThereBe{\Indicator}{1}{\mathbb{1}\set{#1}}
\declareMathematics{\arccot}{arccot}
\declareMathematics{\complexArg}{arg}
\declareMathematics{\gcd}{gcd} % Greatest Common Divisor
\declareMathematics{\lcm}{lcm} % Least Common Multiple

% Operators - Analysis
\LetThereBe{\hess}{\nabla^2}
\LetThereBe{\lagr}{\mcal L}
\LetThereBe{\lapl}{\Delta}
\declareMathematics{\grad}{grad}
\declareMathematics{\Dgrad}{D}
\LetThereBe{\gradient}{\nabla}
\LetThereBe{\jacobi}{\nabla}
\letThereBe{\jacobian}{2}{D_{#1}\brackets{#2}}
\LetThereBe{\d}{\mathrm{d}}
\LetThereBe{\dd}{\,\mathrm{d}}
\letThereBe{\partialDeriv}{2}{\frac {\partial #1} {\partial #2}}
\letThereBe{\npartialDeriv}{3}{\partialDeriv{^{#1} #2} {#3^{#1}}}
\letThereBe{\partialOp}{1}{\frac {\partial} {\partial #1}}
\letThereBe{\npartialOp}{2}{\frac {\partial^{#1}} {\partial #2^{#1}}}
\letThereBe{\pDeriv}{2}{\partialDeriv{#1}{#2}}
\letThereBe{\npDeriv}{3}{\npartialDeriv{#1}{#2}{#3}}
\letThereBe{\deriv}{2}{\frac {\d #1} {\d #2}}
\letThereBe{\nderiv}{3}{\frac {\d^{#1} #2} {\d #3^{#1}}}
\letThereBe{\derivOp}{1}{\frac {\d} {\d #1}\,}
\letThereBe{\nderivOp}{2}{\frac {\d^{#1}} {\d #2^{#1}}\,}

% Useful commands
\letThereBe{\onTop}{2}{\mathrel{\overset{#2}{#1}}}
\letThereBe{\onBottom}{2}{\mathrel{\underset{#2}{#1}}}
\letThereBe{\tOnTop}{2}{\mathrel{\overset{\text{#2}}{#1}}}
\LetThereBe{\EQ}{\onTop{=}{!}}
\LetThereBe{\letDef}{:=} %#TODO: change the symbol
\LetThereBe{\isPDef}{\onTop{\succ}{?}}


% Optimization
\declareMathematicsStar{\argmin}{argmin}
\declareMathematicsStar{\argmax}{argmax}
\declareMathematics{\prox}{prox}
\declareMathematics{\loss}{loss}
\declareMathematics{\supp}{supp}
\letThereBe{\Supp}{1}{\supp\brackets{#1}}
\LetThereBe{\Koop}{\mcal K}
\letThereBe{\oneToN}{1}{\left[#1\right]}
\LetThereBe{\constraint}{\text{s.t.}\;}

% PDEs
% \avint -- defined in format-respective tex files

\LetThereBe{\fundamental}{\Phi}
\LetThereBe{\fund}{\fundamental}
\letThereBe{\normaDeriv}{1}{\partialDeriv{#1}{\vec{n}}}
\letThereBe{\volAvg}{2}{\avint_{\ball{#1}{#2}}}
\LetThereBe{\VolAvg}{\volAvg{x}{\ve}}
\letThereBe{\surfAvg}{2}{\avint_{\boundary \ball{#1}{#2}}}
\LetThereBe{\SurfAvg}{\surfAvg{x}{\ve}}
\LetThereBe{\corrF}{\varphi^{\times}}
\LetThereBe{\greenF}{G}
\letThereBe{\reflect}{1}{\tilde{#1}}
\letThereBe{\unitBall}{1}{\alpha(#1)}
\LetThereBe{\conv}{*}
\letThereBe{\dotP}{2}{#1 \cdot #2}
\letThereBe{\translation}{1}{\tau_{#1}}
\declareMathematics{\dist}{dist}
\letThereBe{\regularizef}{1}{\eta_{#1}}
\letThereBe{\fourier}{1}{\widehat{#1}}
\letThereBe{\ifourier}{1}{\check{#1}}
\LetThereBe{\fourierOp}{\mcal F}
\letThereBe{\Norm}{1}{\absval{#1}}
% Linear algebra
\letThereBe{\norm}{1}{\left\lVert #1 \right\rVert}
\letThereBe{\scal}{2}{\left\langle #1, #2 \right\rangle}
\letThereBe{\avg}{1}{\overline{#1}}
\letThereBe{\Avg}{1}{\bar{#1}}
\letThereBe{\linspace}{1}{\mathrm{lin}\set{#1}}
\letThereBe{\algMult}{1}{\mu_{\mathrm A} \brackets{#1}}
\letThereBe{\geomMult}{1}{\mu_{\mathrm G} \brackets{#1}}
\LetThereBe{\Nullity}{\mathrm{nullity}}
\letThereBe{\nullity}{1}{\Nullity \brackets{#1}}
\LetThereBe{\nulty}{\nu}

% Linear algebra - Matrices
\LetThereBe{\tr}{\top}
\LetThereBe{\Tr}{^\tr}
\LetThereBe{\pinv}{\dagger}
\LetThereBe{\Pinv}{^\dagger}
\LetThereBe{\Inv}{^{-1}}
\LetThereBe{\ident}{\vi{I}}
\letThereBe{\mtr}{1}{\begin{pmatrix}#1\end{pmatrix}}
\letThereBe{\bmtr}{1}{\begin{bmatrix}#1\end{bmatrix}}
\declareMathematics{\trace}{tr}
\declareMathematics{\diagonal}{diag}

% Statistics
\LetThereBe{\iid}{\overset{\text{i.i.d.}}{\sim}}
\LetThereBe{\ind}{\overset{\text{ind}}{\sim}}
\LetThereBe{\condp}{\,\vert\,}
\letThereBe{\complement}{1}{\overline{#1}}

\LetThereBe{\acov}{\gamma}
\LetThereBe{\acf}{\rho}

\LetThereBe{\stdev}{\sigma}
\LetThereBe{\procMean}{\mu}
\LetThereBe{\procVar}{\stdev^2}

\declareMathematics{\variance}{var}
\letThereBe{\Variance}{1}{\variance \brackets{#1}}
\declareMathematics{\cov}{cov}
\declareMathematics{\corr}{cor}

\letThereBe{\sampleVar}{1}{\rnd S^2_{#1}}
\letThereBe{\populationVar}{1}{V_{#1}}

\declareMathematics{\expectedValue}{\mathbb{E}}
\declareMathematics{\rndMode}{Mode}
\letThereBe{\RndMode}{1}{\rndMode\brackets{#1}}
\letThereBe{\expect}{1}{\expectedValue #1}
\letThereBe{\Expect}{1}{\expectedValue \brackets{#1}}
\letThereBe{\expectIn}{2}{\expectedValue_{#1} #2}
\letThereBe{\ExpectIn}{2}{\expectedValue_{#1} \brackets{#2}}

% Distributions
\letThereBe{\WN}{2}{\mathrm{WN}\brackets{#1,#2}}
\declareMathematics{\uniform}{Unif}
\declareMathematics{\binomDist}{Bi}
\declareMathematics{\negbinomDist}{NBi}
\declareMathematics{\betaDist}{Beta}
\declareMathematics{\betabinomDist}{BetaBin}
\declareMathematics{\gammaDist}{Gamma}
\declareMathematics{\invgammaDist}{IGamma}
\declareMathematics{\expDist}{Ex}
\declareMathematics{\poisDist}{Po}
\declareMathematics{\erlangDist}{Er}
\declareMathematics{\altDist}{A}
\declareMathematics{\geomDist}{Ge}
\LetThereBe{\normalDist}{\mathcal N}
\letThereBe{\normalD}{1}{\normalDist \brackets{#1}}
\letThereBe{\mvnormalD}{2}{\normalDist_{#1} \brackets{#2}}
\letThereBe{\NormalD}{2}{\normalDist \brackets{#1, #2}}

\LetThereBe{\betaF}{\mathrm B}
\LetThereBe{\fisherMat}{J}
\LetThereBe{\mutInfo}{I}
\LetThereBe{\expectedGain}{I_e}
\letThereBe{\KLDiv}{2}{D\brackets{#1 \parallel #2}}
\LetThereBe{\entropy}{H}
\LetThereBe{\diffEntropy}{h}

\LetThereBe{\absCont}{\ll}

\LetThereBe{\att}{_t} %at time 
\letThereBe{\estim}{1}{\hat{#1}}
\letThereBe{\estimML}{1}{\hat{#1}_{\mathrm{ML}}}
\letThereBe{\estimOLS}{1}{\hat{#1}_{\mathrm{OLS}}}
\letThereBe{\estimMAP}{1}{\hat{#1}_{\mathrm{MAP}}}
\letThereBe{\predict}{3}{\estim {\rnd #1}_{#2 | #3}}
\letThereBe{\periodPart}{3}{#1+#2-\ceil{#2/#3}#3}
\letThereBe{\infEstim}{1}{\tilde{#1}}
\letThereBe{\predictDist}{1}{{#1}^*}

\LetThereBe{\backs}{\oper B}
\LetThereBe{\diff}{\oper \Delta}
\LetThereBe{\BLP}{\oper P}

\LetThereBe{\arPoly}{\Phi}
\letThereBe{\ArPoly}{1}{\arPoly\brackets{#1}}
\LetThereBe{\maPoly}{\Theta}
\letThereBe{\MaPoly}{1}{\maPoly\brackets{#1}}

\letThereBe{\ARmod}{1}{\mathrm{AR}\brackets{#1}}
\letThereBe{\MAmod}{1}{\mathrm{MA}\brackets{#1}}
\letThereBe{\ARMA}{2}{\mathrm{ARMA}\brackets{#1, #2}}
\letThereBe{\sARMA}{3}{\mathrm{ARMA}\brackets{#1}\brackets{#2}_{#3}}
\letThereBe{\SARIMA}{3}{\mathrm{ARIMA}\brackets{#1}\brackets{#2}_{#3}}
\letThereBe{\ARIMA}{3}{\mathrm{ARIMA}\brackets{#1, #2, #3}}

\LetThereBe{\pacf}{\alpha}
\letThereBe{\parcorr}{3}{\rho_{#1 #2 | #3}}

\LetThereBe{\noise}{\mathscr{N}}
\LetThereBe{\jeffreys}{\mathcal J}

\LetThereBe{\likely}{\mcal L}
\letThereBe{\Likely}{1}{\likely\brackets{#1}}
\LetThereBe{\loglikely}{\mcal l}
\letThereBe{\Loglikely}{1}{\loglikely \brackets{#1}}

\LetThereBe{\CovMat}{\Gamma}
\LetThereBe{\covMat}{\vi \CovMat}
\LetThereBe{\rcovMat}{\vrr \CovMat}

\LetThereBe{\AIC}{\mathrm{AIC}}
\LetThereBe{\BIC}{\mathrm{BIC}}
\LetThereBe{\AICc}{\mathrm{AIC}_c}

\LetThereBe{\nullHypo}{H_0}
\LetThereBe{\altHypo}{H_1}

\LetThereBe{\rve}{\rnd \ve}
\LetThereBe{\rtht}{\rnd \theta}
\LetThereBe{\rX}{\rnd X}
\LetThereBe{\rY}{\rnd Y}
\LetThereBe{\rZ}{\rnd Z}
\LetThereBe{\rA}{\rnd A}
\LetThereBe{\rB}{\rnd B}
\LetThereBe{\vrZ}{\vr Z}
\LetThereBe{\vrY}{\vr Y}
\LetThereBe{\vrX}{\vr X}

% Bayesian inference
\LetThereBe{\paramSet}{\mcal T}
\LetThereBe{\sampleSet}{\mcal Y}
\LetThereBe{\bayesSigmaAlg}{\mcal B}

% Different types of convergence
\LetThereBe{\inDist}{\onTop{\to}{d}}
\letThereBe{\inDistWhen}{1}{\onBottom{\onTop{\longrightarrow}{d}}{#1}}
\LetThereBe{\inProb}{\onTop{\to}{P}}
\letThereBe{\inProbWhen}{1}{\onBottom{\onTop{\longrightarrow}{P}}{#1}}
\LetThereBe{\inMeanSq}{\onTop{\to}{L^2}}
\letThereBe{\inMeanSqWhen}{1}{\onBottom{\onTop{\longrightarrow}{L^2}}{#1}}
\LetThereBe{\convergeAS}{\tOnTop{\to}{a.s.}}
\letThereBe{\convergeASWhen}{1}{\onBottom{\tOnTop{\longrightarrow}{a.s.}}{#1}}

% Asymptotic qualities
\LetThereBe{\simAsymp}{\tOnTop{\sim}{as.}}

% Game Theory
\LetThereBe{\doms}{\succ}
\LetThereBe{\isdom}{\prec}
\letThereBe{\OfOthers}{1}{_{-#1}}
\LetThereBe{\ofOthers}{\OfOthers{i}}
\LetThereBe{\pdist}{\sigma}
\letThereBe{\domGame}{1}{G_{DS}^{#1}}
\letThereBe{\ratGame}{1}{G_{Rat}^{#1}}
\letThereBe{\bestRep}{2}{\mathrm{BR}_{#1}\brackets{#2}}
\letThereBe{\perf}{1}{{#1}_{\mathrm{perf}}}
\LetThereBe{\perfG}{\perf{G}}
\letThereBe{\imperf}{1}{{#1}_{\mathrm{imp}}}
\LetThereBe{\imperfG}{\imperf{G}}
\letThereBe{\proper}{1}{{#1}_{\mathrm{proper}}}
\letThereBe{\finrep}{2}{{#2}_{#1{\text -}\mathrm{rep}}} %T-stage game
\letThereBe{\infrep}{1}{#1_{\mathrm{irep}}}
\LetThereBe{\repstr}{\tau} %strategy in a repeated game
\LetThereBe{\emptyhist}{\epsilon}
\letThereBe{\extrep}{1}{{#1^{\mathrm{rep}}}}
\letThereBe{\avgpay}{1}{#1^{\mathrm{avg}}}

\LetThereBe{\succf}{\pi} %successor function
\LetThereBe{\playf}{\rho} %player function
\LetThereBe{\actf}{\chi} %action function

% ODEs
\LetThereBe{\timeInt}{\mcal I}
\LetThereBe{\stimeInt}{\mcal J}
\LetThereBe{\Wronsk}{\mcal W}
\letThereBe{\wronsk}{1}{\Wronsk \parentheses{#1}}
\LetThereBe{\prufRadius}{\rho}
\LetThereBe{\prufAngle}{\vf}
\LetThereBe{\weyr}{\sigma}
\LetThereBe{\linDifOp}{\mathsf{L}}
\LetThereBe{\Hurwitz}{\vi H}
\letThereBe{\hurwitz}{1}{\Hurwitz \brackets{#1}}
\ExplSyntaxOn
\AtBeginDocument{\NewCommandCopy{\Symbfit}{\schmidt_Symbfit:n}}

\cs_new_protected:Nn \schmidt_Symbfit:n
 {
  \str_case:nnF { #1 }
   {
    {0}{\symbf{0}}
    {1}{\symbf{1}}
    {2}{\symbf{2}}
    {3}{\symbf{3}}
    {4}{\symbf{4}}
    {5}{\symbf{5}}
    {6}{\symbf{6}}
    {7}{\symbf{7}}
    {8}{\symbf{8}}
    {9}{\symbf{9}}
   }
   {\symbfit{#1}}
 }

\ExplSyntaxOff

\renewcommand{\vi}[1]{\Symbfit{#1}}
\renewcommand{\rnd}[1]{\symup{#1}}
\renewcommand{\vr}[1]{\symbfup{#1}}
\renewcommand{\vrr}[1]{\symbfup{#1}}
\renewcommand{\oper}[1]{\symsf{#1}}

\renewcommand{\AA}{\vi A}
\renewcommand{\Avg}[1]{\overline{#1}}

\renewcommand{\loglikely}{\mathscr l}
\KOMAoption{captions}{tableheading}
\makeatletter
\@ifpackageloaded{tcolorbox}{}{\usepackage[skins,breakable]{tcolorbox}}
\@ifpackageloaded{fontawesome5}{}{\usepackage{fontawesome5}}
\definecolor{quarto-callout-color}{HTML}{909090}
\definecolor{quarto-callout-note-color}{HTML}{0758E5}
\definecolor{quarto-callout-important-color}{HTML}{CC1914}
\definecolor{quarto-callout-warning-color}{HTML}{EB9113}
\definecolor{quarto-callout-tip-color}{HTML}{00A047}
\definecolor{quarto-callout-caution-color}{HTML}{FC5300}
\definecolor{quarto-callout-color-frame}{HTML}{acacac}
\definecolor{quarto-callout-note-color-frame}{HTML}{4582ec}
\definecolor{quarto-callout-important-color-frame}{HTML}{d9534f}
\definecolor{quarto-callout-warning-color-frame}{HTML}{f0ad4e}
\definecolor{quarto-callout-tip-color-frame}{HTML}{02b875}
\definecolor{quarto-callout-caution-color-frame}{HTML}{fd7e14}
\makeatother
\makeatletter
\@ifpackageloaded{caption}{}{\usepackage{caption}}
\AtBeginDocument{%
\ifdefined\contentsname
  \renewcommand*\contentsname{Table of contents}
\else
  \newcommand\contentsname{Table of contents}
\fi
\ifdefined\listfigurename
  \renewcommand*\listfigurename{List of Figures}
\else
  \newcommand\listfigurename{List of Figures}
\fi
\ifdefined\listtablename
  \renewcommand*\listtablename{List of Tables}
\else
  \newcommand\listtablename{List of Tables}
\fi
\ifdefined\figurename
  \renewcommand*\figurename{Figure}
\else
  \newcommand\figurename{Figure}
\fi
\ifdefined\tablename
  \renewcommand*\tablename{Table}
\else
  \newcommand\tablename{Table}
\fi
}
\@ifpackageloaded{float}{}{\usepackage{float}}
\floatstyle{ruled}
\@ifundefined{c@chapter}{\newfloat{codelisting}{h}{lop}}{\newfloat{codelisting}{h}{lop}[chapter]}
\floatname{codelisting}{Listing}
\newcommand*\listoflistings{\listof{codelisting}{List of Listings}}
\makeatother
\makeatletter
\makeatother
\makeatletter
\@ifpackageloaded{caption}{}{\usepackage{caption}}
\@ifpackageloaded{subcaption}{}{\usepackage{subcaption}}
\makeatother
\ifLuaTeX
  \usepackage{selnolig}  % disable illegal ligatures
\fi
\usepackage{bookmark}

\IfFileExists{xurl.sty}{\usepackage{xurl}}{} % add URL line breaks if available
\urlstyle{same} % disable monospaced font for URLs
\hypersetup{
  pdftitle={Mushroom analysis},
  colorlinks=true,
  linkcolor={blue},
  filecolor={Maroon},
  citecolor={Blue},
  urlcolor={Blue},
  pdfcreator={LaTeX via pandoc}}

\title{Mushroom analysis}
\usepackage{etoolbox}
\makeatletter
\providecommand{\subtitle}[1]{% add subtitle to \maketitle
  \apptocmd{\@title}{\par {\large #1 \par}}{}{}
}
\makeatother
\subtitle{Project for M9211 Bayesian methods}
\author{Štěpán Zapadlo}
\date{}

\begin{document}
\maketitle

\renewcommand*\contentsname{Table of contents}
{
\hypersetup{linkcolor=}
\setcounter{tocdepth}{3}
\tableofcontents
}
\subsection{Introduction}\label{introduction}

In this project, we will focus on \emph{mushroom classification}
dataset, which can be found
\href{https://www.kaggle.com/datasets/vishalpnaik/mushroom-classification-edible-or-poisonous}{here}.
It is a plain \texttt{.csv} file, so loading is trivial.

\begin{Shaded}
\begin{Highlighting}[]
\NormalTok{data.base }\OtherTok{\textless{}{-}} \FunctionTok{read.csv}\NormalTok{(}\StringTok{"data/mushroom.csv"}\NormalTok{)}
\NormalTok{data.base}\SpecialCharTok{$}\NormalTok{ID }\OtherTok{\textless{}{-}} \FunctionTok{factor}\NormalTok{(}\FunctionTok{seq}\NormalTok{(}\DecValTok{1}\NormalTok{, }\FunctionTok{nrow}\NormalTok{(data.base)))}
\end{Highlighting}
\end{Shaded}

There are a number of categorical columns, among which we shall be
mostly interested in \emph{class}, which indicates whether the mushroom
is edible or not. Moreover, biologically speaking, we expect the
continuous variables, namely \emph{cap diameter}, \emph{stem height} and
\emph{stem width}, to be positive real numbers. This condition will also
become very important soon, as we will discuss and use the
transformation of our data.

\begin{Shaded}
\begin{Highlighting}[]
\NormalTok{data }\OtherTok{\textless{}{-}}\NormalTok{ data.base }\SpecialCharTok{|\textgreater{}} 
  \FunctionTok{na.omit}\NormalTok{() }\SpecialCharTok{|\textgreater{}}
  \FunctionTok{filter}\NormalTok{(cap.diameter }\SpecialCharTok{\textgreater{}} \DecValTok{0} \SpecialCharTok{\&}\NormalTok{ stem.height }\SpecialCharTok{\textgreater{}} \DecValTok{0} \SpecialCharTok{\&}\NormalTok{ stem.width }\SpecialCharTok{\textgreater{}} \DecValTok{0}\NormalTok{)}
\end{Highlighting}
\end{Shaded}

\subsubsection{Normality analysis}\label{normality-analysis}

By plotting the histograms and QQ plots of the continuous variables, see
Figure~\ref{fig-hist-orig}, it becomes apparent that no normality
assumptions can be made.

\begin{figure}[H]

\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-orig-1.png}

}

\subcaption{\label{fig-hist-orig-1}histogram of cap diameter}

\end{minipage}%
%
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-orig-2.png}

}

\subcaption{\label{fig-hist-orig-2}histogram of stem height}

\end{minipage}%
%
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-orig-3.png}

}

\subcaption{\label{fig-hist-orig-3}histogram of stem width}

\end{minipage}%
\newline
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-orig-4.png}

}

\subcaption{\label{fig-hist-orig-4}QQ plot of cap diameter}

\end{minipage}%
%
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-orig-5.png}

}

\subcaption{\label{fig-hist-orig-5}QQ plot of stem height}

\end{minipage}%
%
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-orig-6.png}

}

\subcaption{\label{fig-hist-orig-6}QQ plot of stem width}

\end{minipage}%

\caption{\label{fig-hist-orig}Histograms and QQ plots of continuous
variables}

\end{figure}%

Nonetheless, the logarithmic transformation of these columns grants us
at least approximate normality, see Figure~\ref{fig-hist-log}.

\begin{Shaded}
\begin{Highlighting}[]
\NormalTok{data }\OtherTok{\textless{}{-}}\NormalTok{ data }\SpecialCharTok{|\textgreater{}} \FunctionTok{mutate}\NormalTok{(}
    \AttributeTok{log.cap.diameter =} \FunctionTok{log}\NormalTok{(cap.diameter),}
    \AttributeTok{log.stem.height =} \FunctionTok{log}\NormalTok{(stem.height),}
    \AttributeTok{log.stem.width =} \FunctionTok{log}\NormalTok{(stem.width)}
\NormalTok{)}
\end{Highlighting}
\end{Shaded}

\begin{figure}[H]

\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-log-1.png}

}

\subcaption{\label{fig-hist-log-1}histogram of log of cap diameter}

\end{minipage}%
%
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-log-2.png}

}

\subcaption{\label{fig-hist-log-2}histogram of log of stem height}

\end{minipage}%
%
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-log-3.png}

}

\subcaption{\label{fig-hist-log-3}histogram of log of stem width}

\end{minipage}%
\newline
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-log-4.png}

}

\subcaption{\label{fig-hist-log-4}QQ plot of log of cap diameter}

\end{minipage}%
%
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-log-5.png}

}

\subcaption{\label{fig-hist-log-5}QQ plot of log of stem height}

\end{minipage}%
%
\begin{minipage}{0.33\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-hist-log-6.png}

}

\subcaption{\label{fig-hist-log-6}QQ plot of log of stem width}

\end{minipage}%

\caption{\label{fig-hist-log}Histograms of logs of continuous variables}

\end{figure}%

To better understand the relationship between the continuous variables
and how the log transformation affects them, see Figure~\ref{fig-pairs}.
Also, notice that the (density of) \emph{cap diameter} is
\textbf{bimodal}. The second cluster with higher cap diameters (with an
average approx. 10 times higher than the mean of others) also
corresponds to the same color of the mushrooms' cap -- as such, it may
indicate an error in data, where the researchers used \emph{millimeters}
instead of \emph{centimeters} for the cap diameter of this mushroom
cluster.

\begin{figure}[H]

\begin{minipage}{\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-pairs-1.png}

}

\subcaption{\label{fig-pairs-1}pair plot of continuous variables}

\end{minipage}%
\newline
\begin{minipage}{\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-pairs-2.png}

}

\subcaption{\label{fig-pairs-2}pair plot of logs of continuous
variables}

\end{minipage}%

\caption{\label{fig-pairs}Pair plots of continuous variables per class}

\end{figure}%

\subsubsection{Summary statistics}\label{summary-statistics}

Let us now calculate statistics from our experiment data.

\begin{Shaded}
\begin{Highlighting}[]
\NormalTok{data.poison }\OtherTok{\textless{}{-}}\NormalTok{ data }\SpecialCharTok{|\textgreater{}} \FunctionTok{filter}\NormalTok{(class }\SpecialCharTok{==} \StringTok{\textquotesingle{}p\textquotesingle{}}\NormalTok{)}
\NormalTok{data.poison.cont }\OtherTok{\textless{}{-}}\NormalTok{ data.poison }\SpecialCharTok{|\textgreater{}} 
    \FunctionTok{select}\NormalTok{ (log.cap.diameter, log.stem.height, log.stem.width)}

\NormalTok{data.edible }\OtherTok{\textless{}{-}}\NormalTok{ data }\SpecialCharTok{|\textgreater{}} \FunctionTok{filter}\NormalTok{(class }\SpecialCharTok{==} \StringTok{\textquotesingle{}e\textquotesingle{}}\NormalTok{)}
\NormalTok{data.edible.cont }\OtherTok{\textless{}{-}}\NormalTok{ data.edible }\SpecialCharTok{|\textgreater{}} 
    \FunctionTok{select}\NormalTok{ (log.cap.diameter, log.stem.height, log.stem.width)}

\NormalTok{poison.stat }\OtherTok{\textless{}{-}} \FunctionTok{rbind}\NormalTok{(}
    \AttributeTok{mean =}\NormalTok{ data.poison.cont }\SpecialCharTok{|\textgreater{}} \FunctionTok{summarise\_all}\NormalTok{(mean),}
    \AttributeTok{var =}\NormalTok{ data.poison.cont }\SpecialCharTok{|\textgreater{}} \FunctionTok{summarise\_all}\NormalTok{(var),}
    \AttributeTok{n =}\NormalTok{ data.poison.cont }\SpecialCharTok{|\textgreater{}} \FunctionTok{summarise\_all}\NormalTok{(length)}
\NormalTok{)}

\NormalTok{edible.stat }\OtherTok{\textless{}{-}} \FunctionTok{rbind}\NormalTok{(}
    \AttributeTok{mean =}\NormalTok{ data.edible.cont }\SpecialCharTok{|\textgreater{}} \FunctionTok{summarise\_all}\NormalTok{(mean),}
    \AttributeTok{var =}\NormalTok{ data.edible.cont }\SpecialCharTok{|\textgreater{}} \FunctionTok{summarise\_all}\NormalTok{(var),}
    \AttributeTok{n =}\NormalTok{ data.edible.cont }\SpecialCharTok{|\textgreater{}} \FunctionTok{summarise\_all}\NormalTok{(length)}
\NormalTok{)}
\end{Highlighting}
\end{Shaded}

We can see, among other statistics, the mean height of mushrooms (from
this dataset) is 6.6976831 cm with quite a high standard deviation of
3.2832181 cm. In the Table~\ref{tbl-stats-class}, statistics of the
log-transformed columns are available.

\begin{table}

\caption{\label{tbl-stats-class}Summary statistics per class}

\begin{minipage}{\linewidth}

\begin{verbatim}
# A tibble: 3 x 3
  log.cap.diameter log.stem.height log.stem.width
             <dbl>           <dbl>          <dbl>
1            1.54            1.76           2.03 
2            0.561           0.202          0.789
3        32829           32829          32829    
\end{verbatim}

\end{minipage}%
\newline
\begin{minipage}{\linewidth}

\begin{verbatim}
# A tibble: 3 x 3
  log.cap.diameter log.stem.height log.stem.width
             <dbl>           <dbl>          <dbl>
1            1.83            1.86           2.39 
2            0.462           0.159          0.647
3        27181           27181          27181    
\end{verbatim}

\end{minipage}%

\end{table}%

\subsection{Computations}\label{computations}

\subsubsection{Jeffreys prior}\label{jeffreys-prior}

As I possess little to no knowledge about mushrooms and their
properties, we shall use \emph{Jeffreys prior} for the semi-conjugated
prior distribution. In our case it means \[
p(\mu, \sigma^2) = \jeffreys(\mu, \sigma^2) \propto \frac 1 {\sigma^3}.
\]

\paragraph{Jeffreys prior as a limit
process}\label{jeffreys-prior-as-a-limit-process}

\begin{tcolorbox}[enhanced jigsaw, leftrule=.75mm, titlerule=0mm, left=2mm, coltitle=black, breakable, bottomrule=.15mm, opacityback=0, toprule=.15mm, arc=.35mm, title=\textcolor{quarto-callout-warning-color}{\faExclamationTriangle}\hspace{0.5em}{}, colbacktitle=quarto-callout-warning-color!10!white, colframe=quarto-callout-warning-color-frame, toptitle=1mm, rightrule=.15mm, bottomtitle=1mm, opacitybacktitle=0.6, colback=white]

Note that this is truly an improper distribution and as such, any
attempts to sample from it will fail \emph{spectacularly}. To be even
more clear, not even using a ``cut'' distribution like \[
\jeffreys_{\ve}(\mu, \sigma^2) = \int_\ve^{\sigma^2} \frac 1 {s^3} \, \d s.
\] would help us simulate such probability distribution.

\end{tcolorbox}

Recall that the semi-conjugated distributions for unknown
\((\mu, \sigma^2)\) are \[
\rnd \sigma^2 \sim \invgammaDist\brackets{\frac {b_0} 2, \frac {b_0} 2 \sigma_0^2} \quad \& \quad \brackets{\rnd \mu \condp \rnd \sigma^2 = \sigma^2} \sim \normalD{\mu_0, \frac {\sigma^2} {a_0}},
\] where \(a_0, b_0, \mu_0, \sigma_0^2\) are hyper-parameters. The
Jeffreys prior thus corresponds to limit processes (see
\href{https://www.jarad.me/courses/stat544/slides/Ch02/Ch02b.pdf}{this
lecture}) for variance \[
\alpha \to 0^+ \quad \land \quad \beta \to 0^+
\] and similarly for mean \[
\mu \to 0 \quad \land \quad \sigma^2 \to \infty
\] in their respective distributions, that is
\(\invgammaDist(\alpha, \beta)\) and \(\normalD{\mu, \sigma^2}\).
Returning to our hyper-parameter choice, it corresponds to
\begin{align*}
b_0 &= 0, & \sigma_0^2 &= 0, \\
\mu_0 &= 0, & a_0 &= 0.
\end{align*}

\begin{tcolorbox}[enhanced jigsaw, leftrule=.75mm, titlerule=0mm, left=2mm, coltitle=black, breakable, bottomrule=.15mm, opacityback=0, toprule=.15mm, arc=.35mm, title=\textcolor{quarto-callout-caution-color}{\faFire}\hspace{0.5em}{}, colbacktitle=quarto-callout-caution-color!10!white, colframe=quarto-callout-caution-color-frame, toptitle=1mm, rightrule=.15mm, bottomtitle=1mm, opacitybacktitle=0.6, colback=white]

Bear in mind that these values are only true in the \emph{limit sense}
and as such cannot be used for sampling directly.

\end{tcolorbox}

\paragraph{Simulation of posteriors}\label{simulation-of-posteriors}

Let us also mainly focus on the \textbf{stem height} variable, as it
seems to be the closest to the \emph{normal distribution} (see
Figure~\ref{fig-pairs}). Hence we can now calculate the posterior
parameters -- the posterior probability will be an inverse gamma
distribution, as Jeffreys prior is also inverse gamma in the limit sense
(see above).

With the posterior parameters calculated, we can simulate the
simultaneous distribution for \((\rnd \mu, \rnd \sigma^2)\).

Having computed the posterior parameters and also simulated their
respective distributions, we can plot the results, see
Figure~\ref{fig-jeffrey-sims-result}.

\begin{figure}[H]

\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-sims-result-1.png}

}

\subcaption{\label{fig-jeffrey-sims-result-1}simulation of the expected
value}

\end{minipage}%
%
\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-sims-result-2.png}

}

\subcaption{\label{fig-jeffrey-sims-result-2}excepted value kernel
estimate}

\end{minipage}%
\newline
\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-sims-result-3.png}

}

\subcaption{\label{fig-jeffrey-sims-result-3}simulation of the variance}

\end{minipage}%
%
\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-sims-result-4.png}

}

\subcaption{\label{fig-jeffrey-sims-result-4}variance kernel estimate}

\end{minipage}%

\caption{\label{fig-jeffrey-sims-result}Simulation of posterior
probability}

\end{figure}%

To get an even better picture of the distribution at hand, one can plot
the simulation onto the 2D plane and draw the contour lines of the
corresponding simultaneous 2D multivariate \emph{inverse gamma-normal}
distribution, see Figure~\ref{fig-jeffrey-sims-result-2D}.

\begin{figure}[H]

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-sims-result-2D-1.png}

}

\caption{\label{fig-jeffrey-sims-result-2D}Simultaneous 2D normal
distribution contour from simulation}

\end{figure}%

\paragraph{Posterior statistics of modeled
parameters}\label{posterior-statistics-of-modeled-parameters}

Given our simulated distributions for \(\rnd \mu\) and
\(\rnd \sigma^2\), we can estimate the expected values, \emph{maximum
aposteriori probability} estimates, etc, see
Table~\ref{tbl-jeffreys-posterior-stats}.

\begin{table}

\caption{\label{tbl-jeffreys-posterior-stats}Statistics of posterior
distributions for \(\rnd \mu\) and \(\rnd \sigma^2\) using Jeffreys
prior}

\centering{

\begin{Shaded}
\begin{Highlighting}[]
\NormalTok{sim }\SpecialCharTok{|\textgreater{}} 
  \FunctionTok{group\_by}\NormalTok{(model) }\SpecialCharTok{|\textgreater{}} 
  \FunctionTok{summarise}\NormalTok{(}
    \AttributeTok{mu.MAP =} \FunctionTok{density.max}\NormalTok{(mu, }
          \AttributeTok{from =} \FloatTok{1.5}\NormalTok{, }\AttributeTok{to =} \FloatTok{2.0}\NormalTok{, }\AttributeTok{n =} \DecValTok{1024}\NormalTok{), }
    \AttributeTok{mu.mean =} \FunctionTok{mean}\NormalTok{(mu), }
    \AttributeTok{mu.sd =} \FunctionTok{sd}\NormalTok{(mu), }
    \AttributeTok{mu.ETI.l =} \FunctionTok{t}\NormalTok{(}\FunctionTok{quantile}\NormalTok{(mu, }\FunctionTok{c}\NormalTok{(}\FloatTok{0.025}\NormalTok{))),}
    \AttributeTok{mu.ETI.h =} \FunctionTok{t}\NormalTok{(}\FunctionTok{quantile}\NormalTok{(mu, }\FunctionTok{c}\NormalTok{(}\FloatTok{0.975}\NormalTok{))),}
    \AttributeTok{mu.HDI.l =} \FunctionTok{t}\NormalTok{(}\FunctionTok{hdi}\NormalTok{(mu, }\AttributeTok{credMass =} \FloatTok{0.95}\NormalTok{))[}\DecValTok{1}\NormalTok{], }
    \AttributeTok{mu.HDI.h =} \FunctionTok{t}\NormalTok{(}\FunctionTok{hdi}\NormalTok{(mu, }\AttributeTok{credMass =} \FloatTok{0.95}\NormalTok{))[}\DecValTok{2}\NormalTok{], }
    
    \AttributeTok{sigma2.MAP =} \FunctionTok{density.max}\NormalTok{(sigma2, }\AttributeTok{from =} \FloatTok{0.1}\NormalTok{, }
          \AttributeTok{to =} \FloatTok{0.25}\NormalTok{, }\AttributeTok{n =} \DecValTok{1024}\NormalTok{), }
    \AttributeTok{sigma2.mean =} \FunctionTok{mean}\NormalTok{(sigma2), }
    \AttributeTok{sigma2.sd =} \FunctionTok{sd}\NormalTok{(sigma2), }
    \AttributeTok{sigma2.ETI.l =} \FunctionTok{t}\NormalTok{(}\FunctionTok{quantile}\NormalTok{(sigma2, }\FunctionTok{c}\NormalTok{(}\FloatTok{0.025}\NormalTok{))),}
    \AttributeTok{sigma2.ETI.h =} \FunctionTok{t}\NormalTok{(}\FunctionTok{quantile}\NormalTok{(sigma2, }\FunctionTok{c}\NormalTok{(}\FloatTok{0.975}\NormalTok{))),}
    \AttributeTok{sigma2.HDI.l =} \FunctionTok{t}\NormalTok{(}\FunctionTok{hdi}\NormalTok{(sigma2, }\AttributeTok{credMass =} \FloatTok{0.95}\NormalTok{))[}\DecValTok{1}\NormalTok{], }
    \AttributeTok{sigma2.HDI.h =} \FunctionTok{t}\NormalTok{(}\FunctionTok{hdi}\NormalTok{(sigma2, }\AttributeTok{credMass =} \FloatTok{0.95}\NormalTok{))[}\DecValTok{2}\NormalTok{],  }
\NormalTok{  )}
\end{Highlighting}
\end{Shaded}

\begin{verbatim}
# A tibble: 2 x 15
  model       mu.MAP mu.mean   mu.sd mu.ETI.l[,1] mu.ETI.h[,1] mu.HDI.l mu.HDI.h
  <chr>        <dbl>   <dbl>   <dbl>        <dbl>        <dbl>    <dbl>    <dbl>
1 posterior.~   1.86    1.86 0.00242         1.86         1.87     1.86     1.87
2 posterior.~   1.76    1.76 0.00248         1.75         1.76     1.75     1.76
# i 7 more variables: sigma2.MAP <dbl>, sigma2.mean <dbl>, sigma2.sd <dbl>,
#   sigma2.ETI.l <dbl[,1]>, sigma2.ETI.h <dbl[,1]>, sigma2.HDI.l <dbl>,
#   sigma2.HDI.h <dbl>
\end{verbatim}

}

\end{table}%

For example, we can see that the maximum aposteriori probability \(\mu\)
value is \(6.42\) cm (after \(\exp{}\) transform) for edible mushrooms
while \(5.80\) cm for the poisonous kind. What's more, edible mushrooms
also have lower expected posterior variance.

\paragraph{Predictive distributions}\label{predictive-distributions}

Last but not least, one can calculate the predictive posterior
distribution. In our case, as we worked with an improper prior, it is
unfortunately impossible to simulate a marginal predictive distribution.
Notice the little-to-no distinguishability between edible and poisonous
mushrooms in the posterior predictive distribution, see
Figure~\ref{fig-jeffrey-pred} -- remember that posterior distribution
for both \(\rnd \mu\) and \(\rnd \sigma^2\) showed promising signs of
the ability to distinguish edible and poisonous mushrooms based on their
stem height.

\begin{Shaded}
\begin{Highlighting}[]
\NormalTok{sim.pred }\OtherTok{\textless{}{-}}\NormalTok{ sim }\SpecialCharTok{|\textgreater{}} 
  \FunctionTok{mutate}\NormalTok{(}
    \AttributeTok{z =} \FunctionTok{rnorm}\NormalTok{(mu, mu, }\FunctionTok{sqrt}\NormalTok{(sigma2)), }
    \AttributeTok{model =} \FunctionTok{ifelse}\NormalTok{(model }\SpecialCharTok{==} \StringTok{"prior"}\NormalTok{, }\StringTok{"marginal"}\NormalTok{, model)}
\NormalTok{  )}
\end{Highlighting}
\end{Shaded}

\begin{figure}[H]

\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-pred-1.png}

}

\subcaption{\label{fig-jeffrey-pred-1}simulation of the predictive
distribution}

\end{minipage}%
%
\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-pred-2.png}

}

\subcaption{\label{fig-jeffrey-pred-2}kernel estimate of the predictive
distribution}

\end{minipage}%

\caption{\label{fig-jeffrey-pred}Simulation of the predictive posterior
distribution for the stem height}

\end{figure}%

\paragraph{\texorpdfstring{Student
\(t\)-distribution}{Student t-distribution}}\label{student-t-distribution}

It should be noted, that Hoff (2009) mentions that for a choice of
non-informative prior \(p(\tht, \sigma^2) = \frac 1 {\sigma^2}\), which
leads to the same hyper-parameter choice as with \emph{our} Jeffreys
prior, and the \emph{biased sample variance} \(\frac{n - 1} n s^2\) as
an estimate of the variance, then the posterior distribution of
\(\rnd \theta\) will be the Students \(t\)-distribution, more precisely
\[
\brackets{\frac {\rnd \tht - \avg y} {s / \sqrt{n}} \condp y_1, \dots, y_n} \sim t_{n - 1}.
\]

In our case, we have roughly 60k rows in the dataset, so the Student's
\(t\)-distribution will be neigh indistinguishable from the normal
distribution, as can be seen in Figure~\ref{fig-jeffrey-student-t}.

\begin{figure}[H]

\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-student-t-1.png}

}

\subcaption{\label{fig-jeffrey-student-t-1}simulations}

\end{minipage}%
%
\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-jeffrey-student-t-2.png}

}

\subcaption{\label{fig-jeffrey-student-t-2}kernel estimates}

\end{minipage}%

\caption{\label{fig-jeffrey-student-t}Comparison of posterior
\(\rnd \tht\) as a normal distribution and Student's \(t\)-distribution}

\end{figure}%

\subsubsection{More informative prior}\label{more-informative-prior}

Our choice of Jeffreys prior for its low informativeness made
simulations certainly harder to perform. Thus, we should also consider a
case of a more informative prior about the distribution of the
parameters.

Since my knowledge has not improved in those few paragraphs, I tried
searching for the average mushroom height on Google, but I returned
empty-handed. The next best thing that came into my mind was to employ
ChatGPT 3.5 to get the prior. Thus I used the following prompt:

\begin{quote}
Suppose that the mushroom stem height is governed by the normal
distribution. What should be the expected value and variance?
\end{quote}

ChatGPT answered with the following response (abbreviated):

\begin{quote}
(\ldots) Suppose the mean height of mushroom stems is 2 inches, and the
standard deviation (a measure of spread) is 0.5 inches. In this case:

\begin{enumerate}
\def\labelenumi{\arabic{enumi}.}
\tightlist
\item
  Expected value (mean) = 2 inches
\item
  Variance = (Standard deviation)\^{}2 = (0.5 inch)\^{}2 = 0.25 square
  inch
\end{enumerate}

(\ldots)
\end{quote}

Hence we will from now on assume
\(\Expect{\rnd \mu} = \log(5.08 \, \mathrm{cm}) = 1.63\) and
\(\Variance{\rnd \sigma^2} = \log^2\brackets{\frac {2.54} 4 \, \mathrm{cm}^2} = 0.2062\).
Recall that the expected value of inverse gamma distribution
\(\invgammaDist(\alpha, \beta)\) is given by
\(\frac {\beta} {\alpha - 1}\) for \(\alpha > 1\) (for lower values of
\(\alpha\), the expected value of the distribution does not exist),
which can again be converted into our hyper-parameters to yield \[
\frac {\frac {b_0} 2 \sigma_0^2} {\frac {b_0} 2 - 1} = \frac {\sigma_0^2} {1 - \frac 2 {b_0}} \Bigg|_{b_0 = 100, \sigma_0^2 = 0.2021} = 0.2062.
\] Similarly, we achieve the desired expected value of \(\mu\) by
setting \(\mu_0 = 1.63\) and \(a_0 = 500\).

We can now plot the posterior densities and compare it to now a proper
prior (recall that Jeffreys prior was \emph{improper}, i.e., it was not
a real probability distribution), see
Figure~\ref{fig-chatgpt-posterior}.

\begin{figure}[H]

\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-chatgpt-posterior-1.png}

}

\subcaption{\label{fig-chatgpt-posterior-1}simulation of the expected
value}

\end{minipage}%
%
\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-chatgpt-posterior-2.png}

}

\subcaption{\label{fig-chatgpt-posterior-2}excepted value kernel
estimate}

\end{minipage}%
\newline
\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-chatgpt-posterior-3.png}

}

\subcaption{\label{fig-chatgpt-posterior-3}simulation of the variance}

\end{minipage}%
%
\begin{minipage}{0.50\linewidth}

\centering{

\includegraphics{project_files/figure-pdf/fig-chatgpt-posterior-4.png}

}

\subcaption{\label{fig-chatgpt-posterior-4}variance kernel estimate}

\end{minipage}%

\caption{\label{fig-chatgpt-posterior}Simulation of posterior
probability with ChatGPT-given prior}

\end{figure}%

Last but not least, we should compare the posterior statistics of
Jeffreys and ChatGPT priors, see Table~\ref{tbl-chatgpt-posterior-stats}
and Table~\ref{tbl-jeffreys-posterior-stats}. After close inspection,
one can notice that MAP estimate for \(\rnd \mu\) has \emph{decreased}
by using the ChatGPT prior, which stands to reason as the prior expected
lower values in \(\rnd \mu\) (see Figure~\ref{fig-chatgpt-posterior-2}).

\begin{table}

\caption{\label{tbl-chatgpt-posterior-stats}Statistics of posterior
distributions for \(\rnd \mu\) and \(\rnd \sigma^2\) using ChatGPT
proper prior}

\centering{

\begin{verbatim}
# A tibble: 3 x 15
  model       mu.MAP mu.mean   mu.sd mu.ETI.l[,1] mu.ETI.h[,1] mu.HDI.l mu.HDI.h
  <chr>        <dbl>   <dbl>   <dbl>        <dbl>        <dbl>    <dbl>    <dbl>
1 posterior.~   1.86    1.86 0.00240         1.85         1.86     1.85     1.86
2 posterior.~   1.76    1.76 0.00246         1.75         1.76     1.75     1.76
3 prior         1.63    1.63 0.0203          1.59         1.67     1.59     1.67
# i 7 more variables: sigma2.MAP <dbl>, sigma2.mean <dbl>, sigma2.sd <dbl>,
#   sigma2.ETI.l <dbl[,1]>, sigma2.ETI.h <dbl[,1]>, sigma2.HDI.l <dbl>,
#   sigma2.HDI.h <dbl>
\end{verbatim}

}

\end{table}%

\phantomsection\label{refs}
\begin{CSLReferences}{1}{0}
\bibitem[\citeproctext]{ref-hoff2009first}
Hoff, P. D. 2009. \emph{A First Course in Bayesian Statistical Methods}.
Springer Texts in Statistics. Springer New York.
\url{https://books.google.cz/books?id=V8jT2SimGR0C}.

\end{CSLReferences}



\end{document}
